/// <reference types="react" />
import { RouteProps } from 'react-router-dom';
import { LocationListener, Action } from 'history';
import { SlotRegistry } from '@teambit/harmony';
import { RouteSlot } from '@teambit/ui.react-router.slot-router';
import { Routing } from './routing-method';
declare type RouteChangeSlot = SlotRegistry<LocationListener>;
export declare class ReactRouterUI {
    private routeSlot;
    private routeChangeListener;
    private routerHistory?;
    private routingMode;
    constructor(routeSlot: RouteSlot, routeChangeListener: RouteChangeSlot);
    renderRoutes(routes: RouteProps[]): JSX.Element;
    private unregisterListener?;
    setRouter: (routerHistory: any) => void;
    setRoutingMode(routing: Routing): void;
    register(route: RouteProps): this;
    registerListener(listener: LocationListener): void;
    navigateTo: (path: any, action?: Action | Record<string, any>) => void;
    private legacyNavigateTo;
    static slots: ((registerFn: () => string) => SlotRegistry<any>)[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider(deps: any, config: any, [routeSlot, routeChangeSlot]: [RouteSlot, RouteChangeSlot]): Promise<ReactRouterUI>;
}
export {};
